-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib
lib.classes["WARRIOR"] = {}
local t,s
lib.classes["WARRIOR"][2] = function ()

	cfg.spells={}
	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("bt",{23881}) -- Bloodthirst
	lib.AddSpell("rb",{85288}) -- Raging Blow	
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("cs",{86346}) -- Colossus Smash
	lib.AddSpell("slam",{1464}) -- Slam
	lib.AddSpell("execute",{5308}) -- Execute
	lib.AddSpell("bs",{6673}) -- Battle Shout
	lib.AddSpell("dw",{12292}) -- Death Wish
	lib.AddSpell("hs",{78}) -- Heroic Strike
	
	lib.AddSpell("ir",{1134}) -- Inner Rage
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ww",{1680}) -- Whirlwind
	
				
	cfg.auras={}
	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
	lib.AddAura("Executioner",90806,"buff","player") -- Executioner
	lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
	lib.AddAura("Incite",86627,"buff","player") -- Incite
	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
	lib.AddAura("dw",12292,"buff","player") -- Death Wish
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"cs")
	table.insert(cfg.plistdps,"bt")
	table.insert(cfg.plistdps,"hs_Trance")
	table.insert(cfg.plistdps,"execute")
	table.insert(cfg.plistdps,"rb_enrage")
	table.insert(cfg.plistdps,"slam_bs")
	table.insert(cfg.plistdps,"br")
	table.insert(cfg.plistdps,"bs_single")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"cs")
	table.insert(cfg.plistaoe,"ir")
	table.insert(cfg.plistaoe,"ww")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"rb_aoe")
	table.insert(cfg.plistaoe,"bs")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["execute"] = function()
			t,s = lib.GetAura({"Executioner"})
			if cfg.spells["execute"].isUsable==1 and (s<5 or (s==5 and t<2)) then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["rb_enrage"] = function()
			if lib.GetAura({"Enrage","dw","br"})>0 then
				return lib.SimpleCDCheck("rb")
			end
			return nil
		end,
		["rb_aoe"] = function()
			if lib.GetAura({"Enrage","dw","br"})>0 and cfg.power >= 70  then
				return lib.SimpleCDCheck("rb")
			end
			return nil
		end,
		["cleave"] = function()
			if lib.SpellTL("ww")>2  then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["slam_bs"] = function ()
			if lib.GetAura({"bs"})>0 then
				return lib.SimpleCDCheck("slam")
			end
			return nil
		end,
		["br"] = function ()
			if lib.GetAura({"Enrage","dw","br"})==0 and lib.GetAura({"bs"})==0 and lib.GetAura({"Trance"})==0 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["hs_Trance"] = function ()
			if lib.GetAura({"Trance"})>0 or cfg.power >= 90 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["hs"] = function ()
			if cfg.power == 100 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["bs_single"] = function ()
			if cfg.power < cfg.spells["bt"].powerCost then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}

	lib.myonhealthupdate = function()
		if lib.UpdateSpellCD("execute") then cfg.Update=true end
	end
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	cfg.onpower=true
	return true
end

lib.classes["WARRIOR"][1] = function ()

	lib.AddSpell("Rend",{772}) -- Rend
	cfg.gcd="Rend"
	lib.AddSpell("cs",{86346}) -- Colossus Smash
	lib.AddSpell("ms",{12294}) -- Mortal Strike
	lib.AddSpell("slam",{1464}) -- Slam
	lib.AddSpell("op",{7384}) -- Overpower
	lib.AddSpell("execute",{5308}) -- Execute
	lib.AddSpell("bs",{6673}) -- Battle Shout
	lib.AddSpell("hs",{78}) -- Heroic Strike
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("ir",{1134}) -- Inner Rage
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ss",{12328}) -- Sweeping Strikes
	lib.AddSpell("bls",{46924}) -- Bladestorm
	lib.AddSpell("vr",{34428}) -- Victory Rush
	lib.AddSpell("ww",{1680}) -- Whirlwind
	lib.AddSpell("Clap",{6343}) -- Thunder Clap
	
				
	lib.AddAura("Rend",94009,"debuff","target") -- Rend
	lib.AddAura("cs",86346,"debuff","target") -- Colossus Smash
	lib.AddAura("ToB",60503,"buff","player") -- Taste for Blood
	lib.AddAura("sd",52437,"buff","player") -- Sudden Death
	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
	lib.AddAura("Executioner",90806,"buff","player") -- Executioner
	lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
	lib.AddAura("Incite",86627,"buff","player") -- Incite
	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
	lib.AddAura("Calm",85730,"buff","player") -- Deadly Calm
	
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Rend_noRend")
--	table.insert(cfg.plistdps,"ms_Rend")
	table.insert(cfg.plistdps,"vr")
	table.insert(cfg.plistdps,"cs_nocs")
	table.insert(cfg.plistdps,"ms")
	table.insert(cfg.plistdps,"execute")
	table.insert(cfg.plistdps,"op_ToB")
	table.insert(cfg.plistdps,"hs_Trance")
	table.insert(cfg.plistdps,"slam_noms")
	table.insert(cfg.plistdps,"bs_single")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Rend_bns")
	table.insert(cfg.plistaoe,"Clap_bns")
	table.insert(cfg.plistaoe,"bls")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"ww")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"vr")
	table.insert(cfg.plistaoe,"cs_nocs")
	table.insert(cfg.plistaoe,"execute")
	table.insert(cfg.plistaoe,"ms_aoe")
	table.insert(cfg.plistaoe,"bs_single")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Rend_bns"] = function()
			if cfg.bns and (lib.GetAura({"Calm"})>0 or cfg.power>=(cfg.spells["Rend"].powerCost)) and lib.GetAura({"Rend"})==0 then
				
				return lib.SimpleCDCheck("Rend",nil,true)
			end
			return nil
		end,
		["Clap_bns"] = function()
			if cfg.bns and (lib.GetAura({"Calm"})>0 or cfg.power>=(cfg.spells["Clap"].powerCost)) and lib.GetAura({"Rend"})>0 and cfg.now>(cfg.lastclap+12) then
				return lib.SimpleCDCheck("Clap",nil,true)
			end
			return nil
		end,
		["ww"] = function()
			if lib.GetAura({"Calm"})>0 or cfg.power>=(cfg.spells["ww"].powerCost) then
				return lib.SimpleCDCheck("ww",nil,true,nil,1.5)
			end
			return nil
		end,
		["ms_aoe"] = function()
			if lib.GetAura({"Calm"})>0 or cfg.power>=(cfg.spells["ms"].powerCost+cfg.spells["ww"].powerCost) then
				return lib.SimpleCDCheck("ms")
			end
			return nil
		end,
		["ms"] = function()
			return lib.SimpleCDCheck("ms",nil,nil,nil,1.5)
		end,
		["ms_Rend"] = function()
			t = lib.GetAura({"Rend"})
			if t>0 and t<3 then
				return cfg.case["ms"]()
			end
			return nil
		end,
		["op_ToB"] = function()
			if cfg.spells["execute"].isUsable==nil and (lib.GetAura({"Calm"})>0 or cfg.power>=(cfg.spells["op"].powerCost)) and lib.GetAura({"ToB"})>0 then
				return lib.SimpleCDCheck("op",true,true,true)
			end
			return nil
		end,
		["Rend_noRend"] = function()
			if (lib.GetAura({"Calm"})>0 or cfg.power>=(cfg.spells["Rend"].powerCost)) and lib.GetAura({"Rend"})==0 then
				return lib.SimpleCDCheck("Rend",nil,true,nil,1.5)
			end
			return nil
		end,
		["cs_nocs"] = function()
			if lib.GetAura({"cs"})==0 then
				return lib.SimpleCDCheck("cs",nil,nil,nil,1.5)
			end
			return nil
		end,
		["execute"] = function()
			t,s = lib.GetAura({"Executioner"})
			if cfg.spells["execute"].isUsable==1 and (s<5 or (s==5 and t<3)) then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["cleave"] = function()
			if cfg.power>=(cfg.spells["cleave"].powerCost+cfg.spells["ww"].powerCost) then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["slam_noms"] = function ()
			if cfg.spells["execute"].isUsable==nil and (lib.GetAura({"Calm"})>0 or cfg.power>(cfg.spells["ms"].powerCost+cfg.spells["slam"].powerCost)) then
				return lib.SimpleCDCheck("slam")
			end
			return nil
		end,
		["br"] = function ()
			if lib.GetAura({"Enrage","dw","br"})==0 and lib.GetAura({"bs"})==0 and lib.GetAura({"Trance"})==0 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["hs_Trance"] = function ()
			if lib.GetAura({"Trance"})>0 or cfg.power >= 75 or lib.GetAura({"Calm"})>0 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
--[[		["hs"] = function ()
			if cfg.power == 100 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,]]
		["bs_single"] = function ()
			if cfg.power < cfg.spells["ms"].powerCost then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}

	return true
end


lib.classes["WARRIOR"][3] = function ()

	lib.AddSpell("Rend",{772}) -- Rend
	cfg.gcd="Rend"
	lib.AddSpell("ss",{23922}) -- Shield Slam 
	lib.AddSpell("rv",{6572}) -- Revenge 
	lib.AddSpell("ds",{20243}) -- Devastate 
	lib.AddSpell("Clap",{6343}) -- Thunder Clap
	lib.AddSpell("sw",{46968}) -- Shockwave
	lib.AddSpell("sb",{2565}) -- Shield Block
	
--	lib.AddSpell("execute",{5308}) -- Execute
	
	lib.AddSpell("des",{1160}) -- Demoralizing Shout 
	lib.AddSpell("bs",{6673}) -- Battle Shout
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("ir",{1134}) -- Inner Rage
	
	lib.AddSpell("vr",{34428}) -- Victory Rush
	lib.AddSpell("hs",{78}) -- Heroic Strike
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ht",{57755}) -- Heroic Throw
				
	lib.AddAura("Rend",94009,"debuff","target") -- Rend
	lib.AddAura("snb",50227,"buff","player") -- Sword and Board
	lib.AddAura("ths",87096,"buff","player") -- Thunderstruck
	
	lib.AddAura("Clap1",6343,"debuff","target","any") -- Thunder Clap
	lib.AddAura("Clap2",54404,"debuff","target","any") -- Dust Cloud
	lib.AddAura("Clap3",90315,"debuff","target","any") -- Tailspin
	lib.AddAura("Clap4",8042,"debuff","target","any") -- Earth Shock
	lib.AddAura("Clap5",45477,"debuff","target","any") -- Icy Touch
	lib.AddAura("Clap6",58180,"debuff","target","any") -- Infected Wounds
	lib.AddAura("Clap7",68055,"debuff","target","any") -- Judgements of the Just
	lib.AddAura("Clap8",51693,"debuff","target","any") -- Waylay
	
	lib.AddAura("Demo1",1160,"debuff","target","any") -- Demoralizing Shout 
	lib.AddAura("Demo2",702,"debuff","target","any") -- Curse of Weakness
	lib.AddAura("Demo3",99,"debuff","target","any") -- Demoralizing Roar
	lib.AddAura("Demo4",50256,"debuff","target","any") -- Demoralizing Roar
	lib.AddAura("Demo5",24423,"debuff","target","any") -- Demoralizing Screech
	lib.AddAura("Demo6",81130,"debuff","target","any") -- Scarlet Fever
	lib.AddAura("Demo7",26017,"debuff","target","any") -- Vindication
	
--	lib.AddAura("ToB",60503,"buff","player") -- Taste for Blood
--	lib.AddAura("sd",52437,"buff","player") -- Sudden Death
--	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
--	lib.AddAura("Executioner",90806,"buff","player") -- Executioner
--	lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
--	lib.AddAura("Incite",86627,"buff","player") -- Incite
--	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
--	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
--	lib.AddAura("Calm",85730,"buff","player") -- Deadly Calm
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ht")
	table.insert(cfg.plistdps,"Clap_single")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"vr")
	table.insert(cfg.plistdps,"rv") 
	table.insert(cfg.plistdps,"Rend_noRend") 
	table.insert(cfg.plistdps,"des_noDemo")
	table.insert(cfg.plistdps,"sw_ths")
	table.insert(cfg.plistdps,"sb")
	table.insert(cfg.plistdps,"ds")
	table.insert(cfg.plistdps,"hs")
	table.insert(cfg.plistdps,"bs")
	table.insert(cfg.plistdps,"end")

	
	cfg.plistaoe = {}
--	table.insert(cfg.plistaoe,"vr")
	table.insert(cfg.plistaoe,"Rend_noRend")
	table.insert(cfg.plistaoe,"Clap_bns")
	table.insert(cfg.plistaoe,"sw")
	table.insert(cfg.plistaoe,"des_noDemo")
	table.insert(cfg.plistaoe,"Clap")
	table.insert(cfg.plistaoe,"sb")
	table.insert(cfg.plistaoe,"rv")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"bs")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		--[[["ht"] = function()
			if not lib.inrange("strike") and lib.inrange("ht") then
				return lib.SimpleCDCheck("ht")
			end
			return nil
		end,]]
		["sw_ths"] = function()
			t,s = lib.GetAura({"ths"})
			if t>0 and s==3 then
				return lib.SimpleCDCheck("sw")
			end
			return nil
		end,
		["sw_ths"] = function()
			t,s = lib.GetAura({"ths"})
			if t>0 and s==3 then
				return lib.SimpleCDCheck("sw")
			end
			return nil
		end,
		["Clap_single"] = function()
			t = lib.GetAura({"Rend"})
			if t>0 and t<4 then
				return lib.SimpleCDCheck("Clap")
			end
			return nil
		end,
		["Clap_bns"] = function()
			t = lib.GetAura({"Rend"})
			if cfg.bns and t>0 and (t<3 or cfg.now>(cfg.lastclap+12))  then
				return lib.SimpleCDCheck("Clap")
			end
			return nil
		end,
		["des_noDemo"] = function()
			if lib.GetAuras("Demo")<1 then
				return lib.SimpleCDCheck("des")
			end
			return nil
		end,
		["Rend_noRend"] = function()
			if lib.GetAura({"Rend"})==0 then
				return lib.SimpleCDCheck("Rend")
			end
			return nil
		end,
		["execute"] = function()
			t,s = lib.GetAura({"Executioner"})
			if cfg.spells["execute"].isUsable==1 and (s<5 or (s==5 and t<3)) then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["cleave"] = function()
			if lib.GetAura({"Rend"})>0 and lib.GetAuras("Clap")>0 and cfg.power>=(cfg.spells["cleave"].powerCost+cfg.spells["ss"].powerCost) then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["hs"] = function ()
			if cfg.power>(cfg.spells["hs"].powerCost+cfg.spells["ss"].powerCost) then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["bs"] = function ()
			if cfg.power < cfg.spells["ss"].powerCost then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}

	return true
end

lib.classevents["WARRIOR"] = function()
	cfg.bns=0
	lib.mytal = function()
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,3)
		cfg.bns = currRank>0 and true or nil
	end
	
	cfg.lastclap=0
	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(unit,spell)
		if unit=="player" then
			if spell==cfg.spells["Clap"].name then
				cfg.lastclap=cfg.now
				cfg.Update=true
			elseif spell==cfg.spells["Rend"].name then
				cfg.lastclap=0
				cfg.Update=true
			end
		end
	end
	
	lib.AddSpell("strike",{88161}) -- Strike
	lib.AddSpell("Charge",{100}) -- Charge
	
	lib.rangecheck=function()
		if lib.inrange("strike") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("Charge") then
			lib.bdcolor(Heddframe.bd,{0,1,0,1})
		elseif lib.inrange("ht") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	lib.myonhealthupdate = function()
		if lib.UpdateSpellCD("execute") then cfg.Update=true end
	end
	
	cfg.onpower=true
end